2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see https://www.gnu.org/licenses/ .
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19 echo "Error: The notmuch test suite requires a bash version >= 4.0"
20 echo "due to use of associative arrays within the test suite."
21 echo "Please try again with a newer bash (or help us fix the"
22 echo "test suite to be more portable). Thanks."
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34 echo >&2 'You do not seem to have built notmuch yet.'
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
46 # do not redirect again
48 *' --tee '*|*' --va'*)
50 BASE=test-results/$this_test
51 (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52 echo $? > $BASE.exit) | tee $BASE.out
53 test "$(cat $BASE.exit)" = 0
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
61 # Save STDOUT to fd 6 and STDERR to fd 7.
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
67 # Keep the original TERM for say_color and test_emacs
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
80 # For repeatability, reset the environment to known value.
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89 ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90 echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
108 unset ALTERNATE_EDITOR
113 [ -d ${GNUPGHOME} ] && return
114 _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
115 at_exit_function _gnupg_exit
116 mkdir -m 0700 "$GNUPGHOME"
117 gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
118 test_debug "cat $GNUPGHOME/import.log"
119 if (gpg --quick-random --version >/dev/null 2>&1) ; then
120 echo quick-random >> "$GNUPGHOME"/gpg.conf
121 elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
122 echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
124 echo no-emit-version >> "$GNUPGHOME"/gpg.conf
126 # Change this if we ship a new test key
127 FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
128 SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
129 printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
132 # Each test should start with something like this, after copyright notices:
134 # test_description='Description of this test...
135 # This test checks if command xyzzy does the right thing...
137 # . ./test-lib.sh || exit 1
141 while test "$#" -ne 0
147 immediate=t; shift ;;
155 with_dashes=t; shift ;;
162 valgrind=t; verbose=t; shift ;;
164 shift ;; # was handled already
166 echo "error: unknown test option '$1'" >&2; exit 1 ;;
170 if test -n "$debug"; then
172 printf " %-4s" "[$((test_count - 1))]"
180 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
182 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
183 TERM=$ORIGINAL_TERM &&
195 if test -n "$color"; then
201 error) tput bold; tput setaf 1;; # bold red
202 skip) tput bold; tput setaf 2;; # bold green
203 pass) tput setaf 2;; # green
204 info) tput setaf 3;; # brown
205 *) test -n "$quiet" && return;;
216 test -z "$1" && test -n "$quiet" && return
225 say_color error "error: $*\n"
234 test "${test_description}" != "" ||
235 error "Test script did not set test_description."
237 if test "$help" = "t"
239 echo "Tests ${test_description}"
243 test_description_printed=
244 print_test_description ()
246 test -z "$test_description_printed" || return 0
248 echo $this_test: "Testing ${test_description}"
249 test_description_printed=1
251 if [ -z "$NOTMUCH_TEST_QUIET" ]
253 print_test_description
262 declare -a _exit_functions=()
264 at_exit_function () {
265 _exit_functions=($1 ${_exit_functions[@]/$1})
268 rm_exit_function () {
269 _exit_functions=(${_exit_functions[@]/$1})
276 for _fn in ${_exit_functions[@]}; do $_fn; done
277 rm -rf "$TEST_TMPDIR"
282 if test -n "$GIT_EXIT_OK"
287 say_color error '%-6s' FATAL
288 echo " $test_subtest_name"
290 echo "Unexpected exit while executing $0. Exit code $code."
297 echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
304 say_color error '%-6s' FATAL
307 echo "Unexpected exit while executing $0."
312 # Note: TEST_TMPDIR *NOT* exported!
313 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
314 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
315 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
316 trap 'trap_exit' EXIT
317 trap 'trap_signal' HUP INT TERM
319 # Deliver a message with emacs and add it to the database
321 # Uses emacs to generate and deliver a message to the mail store.
322 # Accepts arbitrary extra emacs/elisp functions to modify the message
323 # before sending, which is useful to doing things like attaching files
324 # to the message and encrypting/signing.
325 emacs_deliver_message ()
330 # before we can send a message, we have to prepare the FCC maildir
331 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
332 # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
333 local smtp_dummy_pid= smtp_dummy_port=
334 eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
335 test -n "$smtp_dummy_pid" || return 1
336 test -n "$smtp_dummy_port" || return 1
339 "(let ((message-send-mail-function 'message-smtpmail-send-it)
340 (mail-host-address \"example.com\")
341 (smtpmail-smtp-server \"localhost\")
342 (smtpmail-smtp-service \"${smtp_dummy_port}\"))
345 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
346 (message-goto-subject)
347 (insert \"${subject}\")
351 (notmuch-mua-send-and-exit))"
353 # In case message was sent properly, client waits for confirmation
354 # before exiting and resuming control here; therefore making sure
355 # that server exits by sending (KILL) signal to it is safe.
356 kill -9 $smtp_dummy_pid
357 notmuch new >/dev/null
360 # Pretend to deliver a message with emacs. Really save it to a file
361 # and add it to the database
363 # Uses emacs to generate and deliver a message to the mail store.
364 # Accepts arbitrary extra emacs/elisp functions to modify the message
365 # before sending, which is useful to doing things like attaching files
366 # to the message and encrypting/signing.
368 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
369 # at the head of the argument list, they are sent directly to "notmuch
370 # new" after message delivery
374 while [[ "$1" =~ ^-- ]]; do
375 nmn_args="$nmn_args $1"
381 # before we can send a message, we have to prepare the FCC maildir
382 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
385 "(let ((message-send-mail-function (lambda () t))
386 (mail-host-address \"example.com\"))
389 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
390 (message-goto-subject)
391 (insert \"${subject}\")
395 (notmuch-mua-send-and-exit))" || return 1
396 notmuch new $nmn_args >/dev/null
399 # Add an existing, fixed corpus of email to the database.
401 # $1 is the corpus dir under corpora to add, using "default" if unset.
403 # The default corpus is based on about 50 messages from early in the
404 # history of the notmuch mailing list, which allows for reliably
405 # testing commands that need to operate on a not-totally-trivial
406 # number of messages.
412 cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
413 notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
416 test_begin_subtest ()
418 if [ -n "$inside_subtest" ]; then
419 exec 1>&6 2>&7 # Restore stdout and stderr
420 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
422 test_subtest_name="$1"
424 # Redirect test output to the previously prepared file descriptors
425 # 3 and 4 (see below)
426 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
431 # Pass test if two arguments match
433 # Note: Unlike all other test_expect_* functions, this function does
434 # not accept a test name. Instead, the caller should call
435 # test_begin_subtest before calling this function in order to set the
439 exec 1>&6 2>&7 # Restore stdout and stderr
440 if [ -z "$inside_subtest" ]; then
441 error "bug in the test script: test_expect_equal without test_begin_subtest"
445 error "bug in the test script: not 2 parameters to test_expect_equal"
449 if ! test_skip "$test_subtest_name"
451 if [ "$output" = "$expected" ]; then
454 testname=$this_test.$test_count
455 echo "$expected" > $testname.expected
456 echo "$output" > $testname.output
457 test_failure_ "$(diff -u $testname.expected $testname.output)"
462 # Like test_expect_equal, but takes two filenames.
463 test_expect_equal_file ()
465 exec 1>&6 2>&7 # Restore stdout and stderr
466 if [ -z "$inside_subtest" ]; then
467 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
471 error "bug in the test script: not 2 parameters to test_expect_equal_file"
475 if ! test_skip "$test_subtest_name"
477 if diff -q "$file1" "$file2" >/dev/null ; then
480 testname=$this_test.$test_count
481 basename1=`basename "$file1"`
482 basename2=`basename "$file2"`
483 cp "$file1" "$testname.$basename1"
484 cp "$file2" "$testname.$basename2"
485 test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
490 # Like test_expect_equal, but arguments are JSON expressions to be
491 # canonicalized before diff'ing. If an argument cannot be parsed, it
492 # is used unchanged so that there's something to diff against.
493 test_expect_equal_json () {
494 # The test suite forces LC_ALL=C, but this causes Python 3 to
495 # decode stdin as ASCII. We need to read JSON in UTF-8, so
496 # override Python's stdio encoding defaults.
497 local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
498 output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
500 expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
503 test_expect_equal "$output" "$expected" "$@"
506 # Sort the top-level list of JSON data from stdin.
508 PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
509 "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
512 # test for json objects:
513 # read the source of test/json_check_nodes.py (or the output when
514 # invoking it without arguments) for an explanation of the syntax.
516 exec 1>&6 2>&7 # Restore stdout and stderr
517 if [ -z "$inside_subtest" ]; then
518 error "bug in the test script: test_json_eval without test_begin_subtest"
522 error "bug in the test script: test_json_nodes needs at least 1 parameter"
524 if ! test_skip "$test_subtest_name"
526 output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON "$TEST_DIRECTORY"/json_check_nodes.py "$@")
531 test_failure_ "$output"
536 test_emacs_expect_t () {
538 error "bug in the test script: not 1 parameter to test_emacs_expect_t"
539 if [ -z "$inside_subtest" ]; then
540 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
544 if ! test_skip "$test_subtest_name"
546 test_emacs "(notmuch-test-run $1)" >/dev/null
548 # Restore state after the test.
549 exec 1>&6 2>&7 # Restore stdout and stderr
552 # Report success/failure.
558 test_failure_ "${result}"
561 # Restore state after the (non) test.
562 exec 1>&6 2>&7 # Restore stdout and stderr
569 notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
574 # this relies on the default format being batch-tag, otherwise some tests will break
575 notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
578 notmuch_drop_mail_headers ()
582 msg = email.message_from_file(sys.stdin)
583 for hdr in sys.argv[1:]: del msg[hdr]
584 print(msg.as_string(False))
588 notmuch_search_sanitize ()
590 perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
593 notmuch_search_files_sanitize ()
598 notmuch_dir_sanitize ()
600 sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
603 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
604 notmuch_show_sanitize ()
606 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
608 notmuch_show_sanitize_all ()
611 -e 's| filename:.*| filename:XXXXX|' \
612 -e 's| id:[^ ]* | id:XXXXX |' | \
613 notmuch_date_sanitize
616 notmuch_json_show_sanitize ()
619 -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
620 -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
621 -e 's|"filename": "signature.asc",||g' \
622 -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
623 -e 's|"timestamp": 97.......|"timestamp": 42|g' \
624 -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
627 notmuch_emacs_error_sanitize ()
635 -e 's/^\[.*\]$/[XXX]/' \
636 -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
639 notmuch_date_sanitize ()
642 -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
645 notmuch_uuid_sanitize ()
647 sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
650 notmuch_built_with_sanitize ()
652 sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
655 notmuch_config_sanitize ()
657 notmuch_dir_sanitize | notmuch_built_with_sanitize
662 awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
665 # End of notmuch helper functions
667 # Use test_set_prereq to tell that a particular prerequisite is available.
669 # The prerequisite can later be checked for by using test_have_prereq.
671 # The single parameter is the prerequisite tag (a simple word, in all
672 # capital letters by convention).
675 satisfied="$satisfied$1 "
679 test_have_prereq () {
688 declare -A test_missing_external_prereq_
689 declare -A test_subtest_missing_external_prereq_
691 # declare prerequisite for the given external binary
692 test_declare_external_prereq () {
694 test "$#" = 2 && name=$2 || name="$binary(1)"
696 if ! hash $binary 2>/dev/null; then
697 test_missing_external_prereq_["${binary}"]=t
700 test_subtest_missing_external_prereq_[\"${name}\"]=t
706 # Explicitly require external prerequisite. Useful when binary is
707 # called indirectly (e.g. from emacs).
708 # Returns success if dependency is available, failure otherwise.
709 test_require_external_prereq () {
711 if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
712 # dependency is missing, call the replacement function to note it
719 # You are not expected to call test_ok_ and test_failure_ directly, use
720 # the text_expect_* functions instead.
723 if test "$test_subtest_known_broken_" = "t"; then
724 test_known_broken_ok_
727 test_success=$(($test_success + 1))
728 if test -n "$NOTMUCH_TEST_QUIET"; then
731 say_color pass "%-6s" "PASS"
732 echo " $test_subtest_name"
736 print_test_description
737 if test "$test_subtest_known_broken_" = "t"; then
738 test_known_broken_failure_ "$@"
741 test_failure=$(($test_failure + 1))
742 test_failure_message_ "FAIL" "$test_subtest_name" "$@"
743 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
747 test_failure_message_ () {
748 say_color error "%-6s" "$1"
751 if [ "$#" != "0" ]; then
752 echo "$@" | sed -e 's/^/ /'
754 if test "$verbose" != "t"; then cat test.output; fi
757 test_known_broken_ok_ () {
759 test_fixed=$(($test_fixed+1))
760 say_color pass "%-6s" "FIXED"
761 echo " $test_subtest_name"
764 test_known_broken_failure_ () {
766 test_broken=$(($test_broken+1))
767 if [ -z "$NOTMUCH_TEST_QUIET" ]; then
768 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
770 test_failure_message_ "BROKEN" "$test_subtest_name"
776 test "$debug" = "" || eval "$1"
781 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
784 eval >&3 2>&4 "$test_cleanup"
789 test_count=$(($test_count+1))
791 for skp in $NOTMUCH_SKIP_TESTS
793 case $this_test.$test_count in
798 case $this_test_bare.$test_count in
806 test_report_skip_ "$@"
809 test_check_missing_external_prereqs_ "$@"
814 test_check_missing_external_prereqs_ () {
815 if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
816 say_color skip >&1 "missing prerequisites: "
817 echo ${!test_subtest_missing_external_prereq_[@]} >&1
818 test_report_skip_ "$@"
824 test_report_skip_ () {
826 say_color skip >&3 "skipping test:"
828 say_color skip "%-6s" "SKIP"
832 test_subtest_known_broken () {
833 test_subtest_known_broken_=t
836 test_expect_success () {
837 exec 1>&6 2>&7 # Restore stdout and stderr
838 if [ -z "$inside_subtest" ]; then
839 error "bug in the test script: test_expect_success without test_begin_subtest"
843 error "bug in the test script: not 1 parameters to test_expect_success"
845 if ! test_skip "$test_subtest_name"
849 # test_run_ may update missing external prerequisites
850 test_check_missing_external_prereqs_ "$@" ||
851 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
860 test_expect_code () {
861 exec 1>&6 2>&7 # Restore stdout and stderr
862 if [ -z "$inside_subtest" ]; then
863 error "bug in the test script: test_expect_code without test_begin_subtest"
867 error "bug in the test script: not 2 parameters to test_expect_code"
869 if ! test_skip "$test_subtest_name"
873 # test_run_ may update missing external prerequisites,
874 test_check_missing_external_prereqs_ "$@" ||
875 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
879 test_failure_ "exit code $eval_ret, expected $1" "$2"
884 # This is not among top-level (test_expect_success)
885 # but is a prefix that can be used in the test script, like:
887 # test_expect_success 'complain and die' '
889 # do something else &&
890 # test_must_fail git checkout ../outerspace
893 # Writing this as "! git checkout ../outerspace" is wrong, because
894 # the failure could be due to a segv. We want a controlled failure.
898 test $? -gt 0 -a $? -le 129 -o $? -gt 192
901 # test_cmp is a helper function to compare actual and expected output.
902 # You can use it like:
904 # test_expect_success 'foo works' '
905 # echo expected >expected &&
907 # test_cmp expected actual
910 # This could be written as either "cmp" or "diff -u", but:
911 # - cmp's output is not nearly as easy to read as diff -u
912 # - not all diff versions understand "-u"
918 # This function can be used to schedule some commands to be run
919 # unconditionally at the end of the test to restore sanity:
921 # test_expect_success 'test core.capslock' '
922 # git config core.capslock true &&
923 # test_when_finished "git config --unset core.capslock" &&
927 # That would be roughly equivalent to
929 # test_expect_success 'test core.capslock' '
930 # git config core.capslock true &&
932 # git config --unset core.capslock
935 # except that the greeting and config --unset must both succeed for
938 test_when_finished () {
940 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
945 test_results_dir="$TEST_DIRECTORY/test-results"
946 mkdir -p "$test_results_dir"
947 test_results_path="$test_results_dir/$this_test"
949 echo "total $test_count" >> $test_results_path
950 echo "success $test_success" >> $test_results_path
951 echo "fixed $test_fixed" >> $test_results_path
952 echo "broken $test_broken" >> $test_results_path
953 echo "failed $test_failure" >> $test_results_path
954 echo "" >> $test_results_path
956 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
958 if [ "$test_failure" = "0" ]; then
959 if [ "$test_broken" = "0" ]; then
968 emacs_generate_script () {
969 # Construct a little test script here for the benefit of the user,
970 # (who can easily run "run_emacs" to get the same emacs environment
971 # for investigating any failures).
972 cat <<EOF >"$TMP_DIRECTORY/run_emacs"
975 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
977 # Here's what we are using here:
979 # --quick Use minimal customization. This implies --no-init-file,
980 # --no-site-file and (emacs 24) --no-site-lisp
982 # --directory Ensure that the local elisp sources are found
984 # --load Force loading of notmuch.el and test-lib.el
986 exec ${TEST_EMACS} --quick \
987 --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
988 --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
991 chmod a+x "$TMP_DIRECTORY/run_emacs"
995 # test dependencies beforehand to avoid the waiting loop below
996 missing_dependencies=
997 test_require_external_prereq dtach || missing_dependencies=1
998 test_require_external_prereq emacs || missing_dependencies=1
999 test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1000 test -z "$missing_dependencies" || return
1002 if [ -z "$EMACS_SERVER" ]; then
1003 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1004 if [ -f "$emacs_tests" ]; then
1005 load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1009 server_name="notmuch-test-suite-$$"
1010 # start a detached session with an emacs server
1011 # user's TERM (or 'vt100' in case user's TERM is known dumb
1012 # or unknown) is given to dtach which assumes a minimally
1013 # VT100-compatible terminal -- and emacs inherits that
1014 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1015 sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1016 --no-window-system \
1018 --eval '(setq server-name \"$server_name\")' \
1019 --eval '(server-start)' \
1020 --eval '(orphan-watchdog $$)'" || return
1021 EMACS_SERVER="$server_name"
1022 # wait until the emacs server is up
1023 until test_emacs '()' >/dev/null 2>/dev/null; do
1028 # Clear test-output output file. Most Emacs tests end with a
1029 # call to (test-output). If the test code fails with an
1030 # exception before this call, the output file won't get
1031 # updated. Since we don't want to compare against an output
1032 # file from another test, so start out with an empty file.
1036 ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1040 # Note: if there is need to print debug information from python program,
1041 # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1042 PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1043 $NOTMUCH_PYTHON -B - > OUTPUT
1047 MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1051 exec_file="test${test_count}"
1052 test_file="${exec_file}.c"
1054 ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1055 echo "== stdout ==" > OUTPUT.stdout
1056 echo "== stderr ==" > OUTPUT.stderr
1057 ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1058 notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1063 test_file="${base_name}.c"
1064 shim_file="${base_name}.so"
1066 ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1069 notmuch_with_shim () {
1072 shim_file="${base_name}.so"
1073 LD_PRELOAD=./${shim_file}${LD_PRELOAD:+:$LD_PRELOAD} notmuch-shared "$@"
1076 # Creates a script that counts how much time it is executed and calls
1077 # notmuch. $notmuch_counter_command is set to the path to the
1078 # generated script. Use notmuch_counter_value() function to get the
1079 # current counter value.
1080 notmuch_counter_reset () {
1081 notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1082 if [ ! -x "$notmuch_counter_command" ]; then
1083 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1084 cat >"$notmuch_counter_command" <<EOF || return
1087 read count < "$notmuch_counter_state_path"
1088 echo \$((count + 1)) > "$notmuch_counter_state_path"
1092 chmod +x "$notmuch_counter_command" || return
1095 echo 0 > "$notmuch_counter_state_path"
1098 # Returns the current notmuch counter value.
1099 notmuch_counter_value () {
1100 if [ -r "$notmuch_counter_state_path" ]; then
1101 read count < "$notmuch_counter_state_path"
1108 test_reset_state_ () {
1109 test -z "$test_init_done_" && test_init_
1111 test_subtest_known_broken_=
1112 test_subtest_missing_external_prereq_=()
1115 # called once before the first subtest
1119 # skip all tests if there were external prerequisites missing during init
1120 test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1124 # Where to run the tests
1125 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1127 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1129 emacs_generate_script
1132 # Use -P to resolve symlinks in our working directory so that the cwd
1133 # in subprocesses like git equals our $PWD (for pathname comparisons).
1134 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1136 if test "$verbose" = "t"
1140 exec 4>test.output 3>&4
1143 for skp in $NOTMUCH_SKIP_TESTS
1146 for skp in $NOTMUCH_SKIP_TESTS
1148 case "$this_test" in
1153 case "$this_test_bare" in
1161 say_color skip >&3 "skipping test $this_test altogether"
1162 say_color skip "skip all tests in $this_test"
1167 # Provide an implementation of the 'yes' utility
1182 # Fix some commands on Windows
1185 # Windows has its own (incompatible) sort and find
1195 # git sees Windows-style pwd
1199 # no POSIX permissions
1200 # backslashes in pathspec are converted to '/'
1201 # exec does not inherit the PID
1204 test_set_prereq POSIXPERM
1205 test_set_prereq BSLASHPSPEC
1206 test_set_prereq EXECKEEPSPID
1210 test -z "$NO_PERL" && test_set_prereq PERL
1211 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1213 # test whether the filesystem supports symbolic links
1214 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1217 # convert variable from configure to more convenient form
1218 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1226 error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1228 # declare prerequisites for external binaries used in tests
1229 test_declare_external_prereq dtach
1230 test_declare_external_prereq emacs
1231 test_declare_external_prereq ${TEST_EMACSCLIENT}
1232 test_declare_external_prereq ${TEST_GDB}
1233 test_declare_external_prereq gpg
1234 test_declare_external_prereq openssl
1235 test_declare_external_prereq gpgsm
1236 test_declare_external_prereq ${NOTMUCH_PYTHON}